# -*- coding: utf-8 -*-
"""
Author: Mark Maxwell
Project: Chapter 2 Answer Key for 'Data Science Using Python and R'
Python 3.7.0
Last Modified 02/09/2020
"""
###############################################
# Chapter 2 - Working with the Data, Page 26-27
###############################################

# Question 11
# Q: Download the program and open the compiler. What is contained in the bottom‐right window? The left (for Python) or top‐left (for R)?
# A: The text editor is defaulted to the left side pane in the Spyder IDE.

# Question 12
# Q: Type a comment stating that you are working on Chapter 2 exercises.
# A: #I am working on Chapter 2 exercises

# Question 13
# Q: Locate the “Run” button and note whether there is a keyboard shortcut.
# A: The run selection or current line button uses the F9 keyboard shortcut by default.

# Question 14
# Q: Execute the comment from the previous exercise. What is the output? Explain your answer.
# A: The comment is not compiled by Python so no output is returned.

# Question 15
# Q: Import the following packages:  For Python, import the pandas and numpy packages. 
# Q: Rename the pandas package “pd” and rename the numpy package “np.” For R, import the ggplot2 package. 
# Q: Make sure you both install and open the package.

import pandas as pd
import numpy as np

# Question 16
# Q: Import the bank_marketing_training data set and name it bank_train.

bank_train = pd.read_csv("/Users/markmaxwell/Desktop/Website Data Sets/bank_marketing_training")

# the above code uses an absolute path or a relative path can be set using the os package

import os

os.chdir("/Users/markmaxwell/Desktop/Website Data Sets/")

bank_train = pd.read_csv("bank_marketing_training")


# Question 17
# Q: Create a contingency table of the variables response and previous_outcome from the bank_train data set. Do not save the output from the code.

pd.crosstab(bank_train['previous_outcome'], bank_train['response'])

# Question 18
# Q: Rerun the code from the previous exercise, this time saving the output as crosstab_01 (for Python code) or t1 (for R code).

crosstab_01 = pd.crosstab(bank_train['previous_outcome'], bank_train['response'])

# Question 19 (Printed as Question 9)
# Q: After saving the output in the previous exercise, display the output using the name of the saved output.

crosstab_01

# Question 20 (Printed as Question 10)
# Q: Save the contingency table under a different name. This time, use your last name and favorite number as the name; for example, larose42.

mark7 = crosstab_01

# Question 21 (Printed as Question 11)
# Q: Save the first nine records of the bank_train data set as their own data frame.

first_nine = bank_train.loc[0:8]

# Question 22 (Printed as Question 12)
# Q: Save the age and marital records of the bank_train data set as their own data frame.

age_marital = bank_train[['age','marital']]

# Question 23 (Printed as Question 13)
# Q: Save the first three records of the age and marital variables as their own data frame.

first_three_age_marital = bank_train.loc[0:2,['age','marital']]

###############################################
# Chapter 2 - Hands on Analysis, Page 27-28
###############################################

# Question 24
# Import the adult_ch3_training data set using the “Heading: Yes” setting. Rename the data set adult once it is imported. 

adult_train = pd.read_csv("/Users/markmaxwell/Desktop/Website Data Sets/adult_ch3_training")

# Question 25
# Q: Write a comment explaining the change in the data set name. 
# A: The name chosen is short but descriptive so the developer can remember what the variable contains. 
# A: A shorter name is preferred since every time the data is needed the variable name needs to be typed in full.

# Question 26
# Q: Import the following packages:  
# Q: a. For Python, import the DecisionTreeClassifier command from the sklearn.tree package. 
# Q: b. For R, import the rpart package. Make sure you both install and open the package.

from sklearn.tree import DecisionTreeClassifier

# Question 27 (Printed as Question 4)
# Q: Create a contingency table of workclass and sex. Save the output as table01. 

table01 = pd.crosstab(adult_train['workclass'],adult_train['sex'])

# Question 28 (Printed as Question 5)
# Q: Create a contingency table of sex and marital status. Save the output as table02. 

table02 = pd.crosstab(adult_train['marital-status'],adult_train['sex'])

# Question 29 (Printed as Question 6)
# Q: Display the sex and workclass values of the person in the first record. 
# Q: What cell of table01 do they belong to? 
# Q: How many other records in the data set have the same sex and workclass values? 

adult_train.loc[0,['sex','workclass']]

# A: the first record is sex : Male, workclass : Self-emp-not-inc 
# A: table01 has this group as the seventh row and second column of the table
# A: table01 shows that this group represents 992 records in the data 

# Question 30 (Printed as Question 7)
# Q: Display the sex and marital status values of the people in records 6–10. 
# Q: Which cells of table02 do they belong to? 
# Q: How many other records in the data set have the same combinations of sex and marital status values? 

adult_train.loc[5:9,['sex','marital-status']]

# A: The 6-10 records of the data contain sex : Male, marital-status : ['Married-civ-spouse','Divorced'] 
# A: sex : Male, marital-status : 'Married-civ-spouse' belongs to row 3 column 2 and contains 6,010 records
# A: sex : Male, marital-status : 'Divorced' belongs to row 1 column 2 and contains 795 records

# Question 31 (Printed as Question 8)
# Q: Create a new data set that has only records whose marital status is “Married‐civ‐spouse” and name the data set adultMarried. 

adultMarried = adult_train.loc[adult_train['marital-status']=='Married-civ-spouse',]

# Question 32 (Printed as Question 9)
# Q: Recreate the contingency table of sex and workclass using the adultMarried data set. What differences do you notice between the sexes? 

pd.crosstab(adultMarried['workclass'],adultMarried['sex'])

# A: The proportion of records for females dropped significantly more than for males indicating is more common for females to be out of the workforce within the 'Married-civ-spouse' marital-status.

# Question 33 (Printed as Question 10)
# Q: Create a new data set that has only records whose age value is greater than 40. Name the new data set adultOver40.

adultOver40 = adult_train.loc[adult_train['age']>40,]

# Question 34 (Printed as Question 11)
# Q: Recreate the contingency table of sex and marital status using the adultOver40 data set. What differences do you notice?

pd.crosstab(adultOver40['marital-status'],adultOver40['sex'])

# A: The 'Never-married' marital-status dropped significantly for the adults over 40 subset.